/**********************************************************
FileName:    DlgRemoteNetNFS.cpp
Description: NAS configuration      
Date:        2008/06/03
Note: 		<Global>struct, macro refer to GeneralDef.h, global variants and API refer to ClientDemo.cpp      
Modification History:      
    <version> <time>         <desc>
    <1.0    > <2008/06/03>       <created>
***********************************************************/
#include "stdafx.h"
#include "clientdemo.h"
#include "DlgRemoteNetNFS.h"
#include ".\dlgremotenetnfs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgRemoteNetNFS dialog


CDlgRemoteNetNFS::CDlgRemoteNetNFS(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRemoteNetNFS::IDD, pParent)
	, m_csNFSIP(_T(""))
	, m_csNFSDir(_T(""))
	, m_iCurDisk(0)
{
	//{{AFX_DATA_INIT(CDlgRemoteNetNFS)
	m_wPort = 0;
	//}}AFX_DATA_INIT
}

void CDlgRemoteNetNFS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRemoteNetNFS)
	DDX_Control(pDX, IDC_COMBO_DISK_TYPE, m_comboDiskType);
	DDX_Control(pDX, IDC_COMBO_NFS_DISK, m_comboNFSDisk);
	DDX_Text(pDX, IDC_EDIT_HIGH_NFS_IP, m_csNFSIP);
	DDX_Text(pDX, IDC_EDIT_NFS_DIR, m_csNFSDir);
	DDX_Text(pDX, IDC_EDIT_PORT, m_wPort);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgRemoteNetNFS, CDialog)
	//{{AFX_MSG_MAP(CDlgRemoteNetNFS)
	ON_BN_CLICKED(IDC_BTN_NFS_SAVE, OnBnClickedBtnNfsSave)
	ON_CBN_SELCHANGE(IDC_COMBO_NFS_DISK, OnCbnSelchangeComboNfsDisk)
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBnClickedBtnExit)	
	ON_CBN_SELCHANGE(IDC_COMBO_DISK_TYPE, OnSelchangeComboDiskType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgRemoteNetNFS message handlers
BOOL CDlgRemoteNetNFS::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();
	CString sTemp = _T("");
	char szTmp[129] = {0};
	DWORD dwReturned = 0;
	char szLan[128] = {0};
	memset(&m_struNetDiskCfg, 0, sizeof(NET_DVR_NET_DISKCFG));
	if (!NET_DVR_GetDVRConfig(m_lServerID, NET_DVR_GET_NET_DISKCFG, 0, &m_struNetDiskCfg, sizeof(NET_DVR_NET_DISKCFG), &dwReturned))
	{
		g_pMainDlg->AddLog(g_pMainDlg->m_iCurDeviceIndex, OPERATION_FAIL_T, "NET_DVR_GET_NET_DISKCFG");
		g_StringLanType(szLan, "ȡʧ", "Get parameter failed");
		AfxMessageBox(szLan);
		GetDlgItem(IDC_BTN_NFS_SAVE)->EnableWindow(FALSE);
		return FALSE;
	}
	//Information of NFS
	for (int i=0; i<MAX_NET_DISK; i++)
	{
		sTemp.Format("%d", i+1);
		m_comboNFSDisk.AddString(sTemp);
	}
	m_iCurDisk = 0;
	m_comboNFSDisk.SetCurSel(m_iCurDisk);
	ZeroMemory(szTmp, 129);
	memcpy(szTmp, m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].sDirectory, 128);
	m_csNFSDir.Format("%s", szTmp);
	m_csNFSIP.Format("%s", m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].struNetDiskAddr.sIpV4);
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/*********************************************************
Function:	OnBnClickedBtnNfsSave
Desc:		Save current NFS config for theselected HD
Input:	
Output:	
Return:	
**********************************************************/
void CDlgRemoteNetNFS::OnBnClickedBtnNfsSave()
{
	UpdateData(TRUE);
	CString sTemp;
	char szLan[128] ={0};
	if (!m_csNFSIP.IsEmpty() && !CheckIPStr(m_csNFSIP))
	{
		g_StringLanType(szLan, "IPַ", "IP address error");
		AfxMessageBox(szLan);
		return;
	}
	ZeroMemory(&m_struNetDiskCfg.struNetDiskParam[m_iCurDisk], sizeof(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk]));
	m_struNetDiskCfg.dwSize = sizeof(m_struNetDiskCfg);
	sprintf(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].struNetDiskAddr.sIpV4, "%s", m_csNFSIP);
	memcpy(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].sDirectory, m_csNFSDir, m_csNFSDir.GetLength());
	if (!NET_DVR_SetDVRConfig(m_lServerID, NET_DVR_SET_NET_DISKCFG, 0, &m_struNetDiskCfg, sizeof(NET_DVR_NET_DISKCFG)))
	{
		g_pMainDlg->AddLog(g_pMainDlg->m_iCurDeviceIndex, OPERATION_FAIL_T, "NET_DVR_SET_NET_DISKCFG");
		g_StringLanType(szLan, "ʧ", "save the parameter failed");
		AfxMessageBox(szLan);					
	}
	else
	{
		g_pMainDlg->AddLog(g_pMainDlg->m_iCurDeviceIndex, OPERATION_SUCC_T, "NET_DVR_SET_NET_DISKCFG"); 
		g_StringLanType(szLan, "ɹ", "save the parameter successfully");
		AfxMessageBox(szLan);
	}
}

/*********************************************************
Function:	OnCbnSelchangeComboNfsDisk
Desc:		nfs disk selection
Input:	
Output:	
Return:	
**********************************************************/
void CDlgRemoteNetNFS::OnCbnSelchangeComboNfsDisk()
{
	UpdateData(TRUE);
	char szLan[128] ={0};
	if (!m_csNFSIP.IsEmpty() && !CheckIPStr(m_csNFSIP))
	{
		g_StringLanType(szLan, "IPַ", "IP address error");
		AfxMessageBox(szLan);
		return;
	}
	CString csIP;
	char szTmp[200] = {0};
	//save the last disk configure
	sprintf(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].struNetDiskAddr.sIpV4, "%s", m_csNFSIP);
	memcpy(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].sDirectory, m_csNFSDir, m_csNFSDir.GetLength());
//	m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].wPort = m_wPort;
//	m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].byNetDiskType = (BYTE)m_comboDiskType.GetCurSel();
	//
	m_iCurDisk = m_comboNFSDisk.GetCurSel();
	// 9000_1.1 [2009-8-6]
	//m_comboDiskType.SetCurSel(m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].byNetDiskType);
// 	if (m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].byNetDiskType == 0)
// 	{
// 		GetDlgItem(IDC_EDIT_PORT)->ShowWindow(SW_HIDE);
// 		GetDlgItem(IDC_STATIC_PORT)->ShowWindow(SW_HIDE);
// 	}
// 	else
// 	{
// 		m_wPort = m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].wPort;
// 		GetDlgItem(IDC_STATIC_PORT)->ShowWindow(SW_SHOW);
// 		GetDlgItem(IDC_EDIT_PORT)->ShowWindow(SW_SHOW);
// 	}
	memcpy(szTmp, m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].struNetDiskAddr.sIpV4, 16);
	csIP.Format("%s", szTmp);
	m_csNFSIP = csIP;
	memset(szTmp, 0, 200);
	memcpy(szTmp, m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].sDirectory, PATHNAME_LEN);
	m_csNFSDir.Format("%s", szTmp);

	UpdateData(FALSE);
}

/*********************************************************
  Function:	OnBnClickedBtnExit
  Desc:		exit
  Input:	
  Output:	
  Return:	
**********************************************************/
void CDlgRemoteNetNFS::OnBnClickedBtnExit()
{
	CDialog::OnCancel();
}



void CDlgRemoteNetNFS::OnSelchangeComboDiskType() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
// 	m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].byNetDiskType = (BYTE)m_comboDiskType.GetCurSel();
// 	if (m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].byNetDiskType == 0)
// 	{
// 		GetDlgItem(IDC_EDIT_PORT)->ShowWindow(SW_HIDE);
// 		GetDlgItem(IDC_STATIC_PORT)->ShowWindow(SW_HIDE);
// 	}
// 	else
// 	{
// 		m_struNetDiskCfg.struNetDiskParam[m_iCurDisk].wPort = m_wPort;
// 		GetDlgItem(IDC_STATIC_PORT)->ShowWindow(SW_SHOW);
// 		GetDlgItem(IDC_EDIT_PORT)->ShowWindow(SW_SHOW);
// 	}
	UpdateData(FALSE);
}
